// this is a very basic template. use it to start writing your own effects.
// if you want effects with lighting start from one of the GouraudXXXX or PhongXXXX effects

// --------------------------------------------------------------------------------------------------
// PARAMETERS:
// --------------------------------------------------------------------------------------------------

//transforms
float4x4 tW: WORLD;        //the models world matrix
float4x4 tV: VIEW;         //view matrix as set via Renderer (EX9)
float4x4 tP: PROJECTION;
float4x4 tWVP: WORLDVIEWPROJECTION;
float4 cAmb : COLOR <String uiname="Color";>  = {1, 1, 1, 1};

float Phase=0;

float MID=0.5;
float Offset=0;
//texture
texture Tex <string uiname="Texture";>;
sampler Samp = sampler_state    //sampler for doing the texture-lookup
{
    Texture   = (Tex);          //apply a texture to the sampler
    MipFilter = LINEAR;         //sampler states
    MinFilter = LINEAR;
    MagFilter = LINEAR;
};

//texture transformation marked with semantic TEXTUREMATRIX to achieve symmetric transformations
float4x4 tTex: TEXTUREMATRIX <string uiname="Texture Transform";>;

//the data structure: "vertexshader to pixelshader"
//used as output data with the VS function
//and as input data with the PS function
struct vs2ps
{
    float4 Pos  : POSITION;
    float2 TexCd : TEXCOORD0;
};
#define TWOPI 6.28318531
#define PI    3.14159265
// --------------------------------------------------------------------------------------------------
// VERTEXSHADERS
// --------------------------------------------------------------------------------------------------
vs2ps VS(
    float4 PosO  : POSITION,
    float4 TexCd : TEXCOORD0)
{
    //inititalize all fields of output struct with 0
    vs2ps Out = (vs2ps)0;

    float x1 = PosO.x;





    float u = (PosO.x) * PI;
    float v = (PosO.y) * PI;



    // PosO.z = (PosO.x * Phase);
     /// float hallo = (PosO.x * MID2 + MID)/hallo2;
    ///PosO.z = (PosO.x * hallo * Phase);
      
      
     //PosO.x = Phase * cos(v) * sin(u) ;
     //PosO.y = Phase * sin(v) * sin(u)

     float factor = ((PosO.x - Offset) / (1 - Offset));
     factor *= factor;
    if (PosO.x > Offset)
        factor /= -2;
    else
        factor = factor;
        factor /= -2;
     
     PosO.z =+ Phase * (sin(u+MID)) *factor;

     //PosO.z =+ (Phase * (sin(u+MID))) ;



     //PosO.y =+ (Phase * (sin(u))) ;
    //voila:
    //abhngig von der Y-Koordinate des aktuellen Vertex
    //wird ein Sinus auf die aktuelle X-Koordinate aufgerechnet
    //PosO.z += (((PosO.x+MID2)*Phase2)*(0.0+PosO.x+MID2)*(PosO.x));
    ////PosO.z += normalize( PosO.z );
    //transform position
    Out.Pos = mul(PosO, tWVP);
    
    //transform texturecoordinates
    Out.TexCd = mul(TexCd, tTex);

    return Out;
}

// --------------------------------------------------------------------------------------------------
// PIXELSHADERS:
// --------------------------------------------------------------------------------------------------

float4 PS(vs2ps In): COLOR
{
    //In.TexCd = In.TexCd / In.TexCd.w; // for perpective texture projections (e.g. shadow maps) ps_2_0

    float4 col = tex2D(Samp, In.TexCd) * cAmb;
    return col;
}
// --------------------------------------------------------------------------------------------------
// TECHNIQUES:
// --------------------------------------------------------------------------------------------------

technique TSimpleShader
{
    pass P0
    {
        //Wrap0 = U;  // useful when mesh is round like a sphere
        VertexShader = compile vs_1_1 VS();
        PixelShader  = compile ps_1_0 PS();
    }
}

technique TFixedFunction
{
    pass P0
    {
        //transforms
        WorldTransform[0]   = (tW);
        ViewTransform       = (tV);
        ProjectionTransform = (tP);

        //texturing
        Sampler[0] = (Samp);
        TextureTransform[0] = (tTex);
        TexCoordIndex[0] = 0;
        TextureTransformFlags[0] = COUNT2;
        //Wrap0 = U;  // useful when mesh is round like a sphere
        
        Lighting       = FALSE;

        //shaders
        VertexShader = NULL;
        PixelShader  = NULL;
    }
}
